当前位置:   article > 正文

[Leetcode]673. 最长递增子序列的个数_数列673

数列673

给定一个未排序的整数数组 nums , 返回最长递增子序列的个数 。

注意 这个数列必须是 严格 递增的。

示例 1:

输入: [1,3,5,4,7]
输出: 2
解释: 有两个最长递增子序列,分别是 [1, 3, 4, 7] 和[1, 3, 5, 7]。
示例 2:

输入: [2,2,2,2,2]
输出: 5
解释: 最长递增子序列的长度是1,并且存在5个子序列的长度为1,因此输出5。
 

提示: 

1 <= nums.length <= 2000
-106 <= nums[i] <= 106

code

  1. public class FindNumberOfLIS {
  2. // 673. 最长递增子序列的个数
  3. public int findNumberOfLIS(int[] nums) {
  4. int len = nums.length;
  5. int[] dp = new int[len];
  6. int[] cnt = new int[len];
  7. Arrays.fill(dp, 1);
  8. Arrays.fill(cnt, 1);
  9. int maxlen = 0, ans = 0;
  10. for (int i = 0; i < len; i++) {
  11. for (int j = 0; j < i; j++) {
  12. if (nums[i] > nums[j]) {
  13. if (dp[j] + 1 > dp[i]) {
  14. dp[i] = dp[j] + 1;
  15. cnt[i] = cnt[j];
  16. } else if (dp[j] + 1 == dp[i]) {
  17. cnt[i] += cnt[j];
  18. }
  19. }
  20. }
  21. if (dp[i] > maxlen) {
  22. maxlen = dp[i];
  23. ans = cnt[i];
  24. } else if (dp[i] == maxlen) {
  25. ans += cnt[i];
  26. }
  27. }
  28. return ans;
  29. }
  30. public static void main(String[] args) {
  31. int[] nums = new int[]{1, 3, 5, 4, 7};
  32. FindNumberOfLIS solution = new FindNumberOfLIS();
  33. System.out.println(solution.findNumberOfLIS(nums));
  34. }
  35. }

声明:本文内容由网友自发贡献,不代表【wpsshop博客】立场,版权归原作者所有,本站不承担相应法律责任。如您发现有侵权的内容,请联系我们。转载请注明出处:https://www.wpsshop.cn/w/IT小白/article/detail/521515
推荐阅读
相关标签
  

闽ICP备14008679号